Index: issm/trunk/etc/environment.sh
===================================================================
--- issm/trunk/etc/environment.sh	(revision 12709)
+++ issm/trunk/etc/environment.sh	(revision 13395)
@@ -1,3 +1,51 @@
 #ISSM_DIR and ISSM_ARCH should have been defined already in your shell settings file (.bashrc, .cshrc, etc ...)
+
+pathprepend(){ #{{{
+	if [ -d "$1" ] && [[ ":$PATH:" != *":$1:"* ]]; then
+		PATH="$1:$PATH"
+	fi
+} #}}}
+pathappend(){ #{{{
+	if [ -d "$1" ] && [[ ":$PATH:" != *":$1:"* ]]; then
+		export PATH="$PATH:$1"
+	fi
+} #}}}
+libpathprepend(){ #{{{
+	if [ -d "$1" ] && [[ ":$LD_LIBRARY_PATH:" != *":$1:"* ]]; then
+		export LD_LIBRARY_PATH="$1:$LD_LIBRARY_PATH"
+	fi
+	if [ -d "$1" ] && [[ ":$LD_RUN_PATH:" != *":$1:"* ]]; then
+		export LD_RUN_PATH="$1:$LD_RUN_PATH"
+	fi
+} #}}}
+libpathappend(){ #{{{
+	if [ -d "$1" ] && [[ ":$LD_LIBRARY_PATH:" != *":$1:"* ]]; then
+		export LD_LIBRARY_PATH="$LD_LIBRARY_PATH:$1"
+	fi
+	if [ -d "$1" ] && [[ ":$LD_RUN_PATH:" != *":$1:"* ]]; then
+		export LD_RUN_PATH="$LD_RUN_PATH:$1"
+	fi
+} #}}}
+dylibpathprepend(){ #{{{
+	if [ -d "$1" ] && [[ ":$DYLD_LIBRARY_PATH:" != *":$1:"* ]]; then
+		export DYLD_LIBRARY_PATH="$1:$DYLD_LIBRARY_PATH"
+	fi
+	if [ -d "$1" ] && [[ ":$LD_RUN_PATH:" != *":$1:"* ]]; then
+		export LD_RUN_PATH="$1:$LD_RUN_PATH"
+	fi
+} #}}}
+dylibpathappend(){ #{{{
+	if [ -d "$1" ] && [[ ":$DYLD_LIBRARY_PATH:" != *":$1:"* ]]; then
+		export DYLD_LIBRARY_PATH="$DYLD_LIBRARY_PATH:$1"
+	fi
+	if [ -d "$1" ] && [[ ":$LD_RUN_PATH:" != *":$1:"* ]]; then
+		export LD_RUN_PATH="$LD_RUN_PATH:$1"
+	fi
+} #}}}
+
+#FIXME: during installation packages are installed one by one but environment.sh was sourced
+#before so new packages are NOT in the path.
+#may resource environment.sh with:
+#if [ -z $(echo "$PATH" | grep "$MATLAB_DIR") ]; then export $PATH...; fi
 
 #Windows compilers: 
@@ -6,290 +54,214 @@
 fi
 
-source $ISSM_DIR/etc/environment_variables.sh
-
-#Do we have any command line arguments? (such as MATLAB_DIR=otherdirthandefault), source them after exporting the variables
-#to environment.
-for i in $@
-do
-	eval $i
-done
-
-#CRON utilities
-PATH="$PATH:$ISSM_DIR/cron"
-
-#scripts
-PATH="$PATH:$ISSM_DIR/scripts"
-
-##MATLAB
+#Some basic path, in case it is not included by default
+libpathappend "/usr/local/lib"
+
+#Load ISSM scripts
+pathappend "$ISSM_DIR/scripts"
+
+MATLAB_DIR="$ISSM_DIR/externalpackages/matlab/install"
 export MATLAB_DIR
-PATH="$MATLAB_DIR/bin:$PATH" #take precedence over /usr/local/bin/matlab
-export LD_LIBRARY_PATH="$LD_LIBRARY_PATH:$MATLAB_DIR/lib"
-export LD_RUN_PATH="$LD_RUN_PATH:$MATLAB_DIR/lib"
-#export LD_LIBRARY_PATH="$LD_LIBRARY_PATH:$MATLAB_DIR/bin/glnxa64"
-#export LD_RUN_PATH="$LD_RUN_PATH:$MATLAB_DIR/bin/glnxa64"
-
-#MPI
+pathprepend   "$MATLAB_DIR/bin" #take precedence over /usr/local/bin/matlab
+libpathappend "$MATLAB_DIR/lib"
+
+MPI_DIR="$ISSM_DIR/externalpackages/mpich2/install"
 export MPI_DIR
-PATH="$MPI_DIR/bin:$PATH"
-export LD_LIBRARY_PATH="$LD_LIBRARY_PATH:$MPI_DIR/lib"
-export LD_RUN_PATH="$LD_RUN_PATH:$MPI_DIR/lib"
-export MANPATH="$MANPATH:$MPI_DIR/man"
-export MPIRUN_NPROCS=24
-
-#PETSC
+pathprepend   "$MPI_DIR/bin"
+libpathappend "$MPI_DIR/lib"
+
+PETSC_DIR="$ISSM_DIR/externalpackages/petsc/install"
 export PETSC_DIR
-export LD_LIBRARY_PATH="$LD_LIBRARY_PATH:$PETSC_DIR/lib/$ISSM_ARCH"
-export LD_RUN_PATH="$LD_RUN_PATH:$PETSC_DIR/lib/$ISSM_ARCH"
-
-#SLEPC
-export SLEPC_DIR
-export LD_LIBRARY_PATH="$LD_LIBRARY_PATH:$SLEPC_DIR/lib/$ISSM_ARCH"
-export LD_RUN_PATH="$LD_RUN_PATH:$SLEPC_DIR/lib/$ISSM_ARCH"
-
-#Dakota
-export DAKOTA_DIR
-PATH="$PATH:$DAKOTA_DIR/bin"
-export MANPATH="$MANPATH:$MPI_DIR/man:$DAKOTA_DIR/docs/man:$DAKOTA_DIR/docs/man-ref"
-
-#Qhull
-export QHULL_DIR
-export LD_LIBRARY_PATH="$LD_LIBRARY_PATH:$QHULL_DIR/lib"
-export LD_RUN_PATH="$LD_RUN_PATH:$QHULL_DIR/lib"
-
-#Doxygen
-export DOXYGEN_DIR
-MANPATH="$MANPATH:$DOXYGEN_DIR/man"
-PATH="$PATH:$DOXYGEN_DIR/bin"
-
-#MTOC
-export MTOC_DIR
-PATH="$PATH:$MTOC_DIR"
-
-#TRIANGLE
-export TRIANGLE_DIR
-
-#METIS
-export METIS_DIR
-	
-#BLAS
-export BLAS_DIR
-
-#LAPACK
-export LAPACK_DIR
-
-#SCALAPACK
-export SCALAPACK_DIR
-
-#PLAPACK
-export PLAPACK_DIR
-
-#BLACS
-export BLACS_DIR
-
-#YAMS
-export YAMS_DIR
-PATH="$PATH:$YAMS_DIR"
-
-#BAMG
-export BAMG_DIR
-PATH="$PATH:$BAMG_DIR"
-
-#TEX2IM
-export TEX2IM_DIR
-PATH="$PATH:$TEX2IM_DIR"
-
-#SOWING
-export SOWING_DIR
-PATH="$PATH:$SOWING_DIR/bin"
-export LD_LIBRARY_PATH="$LD_LIBRARY_PATH:$SOWING_DIR/lib"
-export LD_RUN_PATH="$LD_RUN_PATH:$SOWING_DIR/lib"
-export MANPATH="$MANPATH:$SOWING_DIR/man"
-
-#Chaco
-export CHACO_DIR
-PATH="$PATH:$CHACO_DIR"
-
-#MeshPart
-export MESHPART_DIR
-PATH="$PATH:$MESHPART_DIR"
-
-#SCOTCH
-export SCOTCH_DIR
-PATH="$PATH:$SCOTCH_DIR"
-export MANPATH="$MANPATH:$SCOTCH_DIR/man"
-
-#AUTOCONF
-export AUTOCONF_DIR
-PATH="$AUTOCONF_DIR/bin:$PATH"
-
-#AUTOMAKE
-export AUTOMAKE_DIR
-PATH="$AUTOMAKE_DIR/bin:$PATH"
-
-export LIBTOOL_DIR
-PATH="$LIBTOOL_DIR/bin:$PATH"
-
-#BORLAND
-export BORLAND_DIR
-PATH="$PATH:$BORLAND_DIR/Bin"
-
-#INTEL
-#export INTEL_DIR
-#PATH="$PATH:$INTEL_DIR"
-#source $ISSM_DIR/externalpackages/intel/intel.sh
-
-#SDK
-export SDK_DIR
-PATH="$PATH:$SDK_DIR"
-
-#SSH
-export SSH_DIR
-PATH="$PATH:$SSH_DIR"
-
-#VALGRIND
-export VALGRIND_DIR
-PATH="$PATH:$VALGRIND_DIR"
-
-#GRAPHVIZ
-export GRAPHVIZ_DIR
-PATH="$PATH:$GRAPHVIZ_DIR"
-
-#CPPCHECK
-export CPPCHECK_DIR
-PATH="$PATH:$CPPCHECK_DIR"
-
-#GDAL
-export GDAL_DIR
-PATH="$GDAL_DIR/bin:$PATH"
-export LD_LIBRARY_PATH="$LD_LIBRARY_PATH:$GDAL_DIR/lib"
-
-#MERCURIAL
-export PYTHONPATH="$PYTHONPATH:$MERCURIAL_DIR/mercurial/pure/"
-export PATH="$PATH:$MERCURIAL_DIR/"
-
-#BOOST
-export BOOSTROOT
-export BOOST_DIR
-export LD_LIBRARY_PATH="$LD_LIBRARY_PATH:$BOOST_DIR/lib"
-export DYLD_LIBRARY_PATH="$DYLD_LIBRARY_PATH:$BOOST_DIR/lib"
-export PATH="$PATH:$BOOST_DIR/bin"
-
-#XERCES
-export XERCESROOT 
-export XERCESCROOT
-
-#xaifBooster
-export XAIFBOOSTERROOT
-export XAIFBOOSTER_HOME
-export XAIF_DIR
-export PLATFORM
-
-#angel
-export ANGELROOT
-
-#openanalysis
-export OPENANALYSISROOT
-export LD_LIBRARY_PATH="$LD_LIBRARY_PATH:$OPENANALYSISROOT/lib"
-
-#JAVA
-export LD_LIBRARY_PATH="$LD_LIBRARY_PATH:$JVM_DIR"
-
-#BBFTP
-export PATH="$PATH:$BBFTP_DIR/bin"
-
-#ADIC
-export PATH="$PATH:$ADIC_DIR/bin"
-export LD_LIBRARY_PATH="$LD_LIBRARY_PATH:$ADIC_DIR/lib"
-export LD_RUN_PATH="$LD_RUN_PATH:$ADIC_DIR/lib"
-
-#COLPACK
-export LD_LIBRARY_PATH="$LD_LIBRARY_PATH:$COLPACK_DIR/lib"
-export LD_RUN_PATH="$LD_RUN_PATH:$COLPACK_DIR/lib"
-
-#ECLIPSE
-export PATH="$PATH:$ECLIPSE_DIR"
-
-#FLAIM
-export FLAIM_DIR
-
-#APPSCAN
-export PATH="$PATH:$APPSCAN_DIR/install/bin"
-export PATH="$PATH:$APPSCAN_DIR/bin"
-
-#CPPCHECK
-export PATH="$PATH:$CPPCHECK_DIR/bin"
-
-#RATS
-export PATH="$PATH:$RATS_DIR/bin"
-
-#DYSON
-export PATH="$PATH:$DYSON_DIR"
-
-#CMAKE
-export PATH="$PATH:$CMAKE_DIR/bin"
-
-#SHAPELIB
-export PATH="$PATH:$SHAPELIB_DIR/exec"
-
-#CCCL
-export PATH="$PATH:$CCCL_DIR/bin"
-
-#PACKAGEMAKER
-export PATH="$PATH:$PACKAGEMAKER_DIR"
-
-#ANDROID_NDK:
-export ANDROID_NDK_DIR
-export PATH="$PATH:$ANDROID_NDK_DIR/"
-
-#ANDROID_DIR
-export ANDROID_DIR
-
-#ANDROID_SDK
-export PATH="$PATH:$ANDROID_SDK_DIR/"
-
-#ANDROID_ANT
-export PATH="$PATH:$ANDROID_ANT_DIR/"
-
-#GSL
-export PATH="$PATH:$GSL_DIR/bin"
-export LD_LIBRARY_PATH="$LD_LIBRARY_PATH:$GSL_DIR/lib"
-export LD_RUN_PATH="$LD_RUN_PATH:$GSL_DIR/lib"
-
-#GMAKE
-export PATH="$GMAKE_DIR/bin:$PATH"
-
-#PYTHON
-export PATH="$PYTHON_DIR/bin:$PATH"
-export PYTHONPATH="$PYTHONPATH:$ISSM_DIR/src/modules/python"
-export LD_LIBRARY_PATH=$ISSM_DIR/src/modules/python:$ISSM_DIR/externalpackages/python/install/lib:$LD_LIBRARY_PATH
-export PYTHONSTARTUP
-
-#MODELE
-export PATH="$MODELE_DIR/src/exec:$PATH"
-
-#GIT
-export PATH="$PATH:$GIT_DIR/install/bin"
-
-#NCVIEW
-export PATH="$PATH:$NCVIEW_DIR/install"
-
-#TCLX
-export LD_LIBRARY_PATH="$LD_LIBRARY_PATH:$TCLX_DIR"
-export LD_RUN_PATH="$LD_RUN_PATH:$TCLX_DIR"
-
-
-#ASPELL
-export PATH="$ASPELL_DIR/install/bin:$PATH"
-
-
-#ESMF
-export ESMF_DIR=$ISSM_DIR/externalpackages/esmf/esmf
-export ESMF_COMPILER=gfortran
-export ESMF_COMM=mpich2
-
-#HDF5
-export DYLD_LIBRARY_PATH="$DYLD_LIBRARY_PATH:$HDF5_DIR/lib"
-export LD_LIBRARY_PATH="$LD_LIBRARY_PATH:$HDF5_DIR/lib"
-export LIBRARY_PATH="$LIBRARY_PATH:$HDF5_DIR/lib"
-export C_INCLUDE_PATH="$C_INCLUDE_PATH:$HDF5_DIR/include"
-
+libpathappend "$PETSC_DIR/lib"
+
+SLEPC_DIR="$ISSM_DIR/externalpackages/slepc/install"
+libpathappend "$SLEPC_DIR/lib/$ISSM_ARCH"
+
+TAO_DIR="$ISSM_DIR/externalpackages/tao/install"
+libpathappend "$TAO_DIR/lib"
+
+DAKOTA_DIR="$ISSM_DIR/externalpackages/dakota/install"
+pathappend "$DAKOTA_DIR/bin"
+
+DOXYGEN_DIR="$ISSM_DIR/externalpackages/doxygen/install"
+pathappend "$DOXYGEN_DIR/bin"
+
+AUTOTOOLS_DIR="$ISSM_DIR/externalpackages/autotools/install"
+pathprepend "$AUTOTOOLS_DIR/bin"
+
+SDK_DIR="C:/MicrosoftVisualStudio 9.0/Microsoft Visual C++ 2008 Express Edition with SP1 - ENU"
+pathappend "$SDK_DIR"
+
+SSH_DIR="$ISSM_DIR/externalpackages/ssh"
+pathappend "$SSH_DIR"
+
+VALGRIND_DIR="$ISSM_DIR/externalpackages/valgrind/install"
+pathprepend "$VALGRIND_DIR/bin"
+
+CPPCHECK_DIR="$ISSM_DIR/externalpackages/cppcheck/install"
+pathappend "$CPPCHECK_DIR/bin"
+
+GDAL_DIR="$ISSM_DIR/externalpackages/gdal/install"
+pathprepend "$GDAL_DIR/bin:$PATH"
+libpathappend "$GDAL_DIR/lib"
+
+MERCURIAL_DIR="$ISSM_DIR/externalpackages/mercurial/install"
+if [ -d "$MERCURIAL_DIR" ]; then
+	export PYTHONPATH="$PYTHONPATH:$MERCURIAL_DIR/mercurial/pure/"
+	pathappend "$MERCURIAL_DIR"
+fi
+
+BOOST_DIR="$ISSM_DIR/externalpackages/boost/install"
+BOOSTROOT="$ISSM_DIR/externalpackages/boost/install"
+if [ -d "$BOOST_DIR" ]; then
+	export BOOSTROOT
+	export BOOST_DIR
+	libpathappend   "$BOOST_DIR/lib"
+	dylibpathappend "$BOOST_DIR/lib"
+	pathappend      "$BOOST_DIR/bin"
+fi
+
+XERCESROOT="$ISSM_DIR/externalpackages/xerces/install"
+XERCESCROOT="$ISSM_DIR/externalpackages/xerces/src"
+if [ -d "$XERCESROOT" ]; then
+	export XERCESROOT 
+	export XERCESCROOT
+fi
+
+XAIF_DIR="$ISSM_DIR/externalpackages/xaifbooster/xaifBooster"
+XAIFBOOSTERROOT="$ISSM_DIR/externalpackages/xaifbooster/"
+XAIFBOOSTER_HOME="$ISSM_DIR/externalpackages/xaifbooster/xaifBooster"
+PLATFORM="x86-Linux"
+if [ -d "$XAIF_DIR" ]; then
+	export XAIFBOOSTERROOT
+	export XAIFBOOSTER_HOME
+	export XAIF_DIR
+	export PLATFORM
+fi
+
+ANGELROOT="$ISSM_DIR/externalpackages/angel/angel"
+if [ -d "$ANGELROOT" ]; then
+	export ANGELROOT
+fi
+
+OPENANALYSISROOT="$ISSM_DIR/externalpackages/openanalysis/install"
+if [ -d "$OPENANALYSISROOT" ]; then
+	export OPENANALYSISROOT
+	libpathappend "$OPENANALYSISROOT/lib"
+fi
+
+JVM_DIR="/usr/local/gcc/4.3.2/lib64/gcj-4.3.2-9/"
+libpathappend "$JVM_DIR"
+
+BBFTP_DIR="$ISSM_DIR/externalpackages/bbftp/install"
+pathappend "$BBFTP_DIR/bin"
+
+ADIC_DIR="$ISSM_DIR/externalpackages/adic/install"
+pathappend "$ADIC_DIR/bin"
+libpathappend "$ADIC_DIR/lib"
+
+COLPACK_DIR="$ISSM_DIR/externalpackages/colpack/install"
+libpathappend "$COLPACK_DIR/lib"
+
+ECLIPSE_DIR="$ISSM_DIR/externalpackages/eclipse/install"
+pathappend "$ECLIPSE_DIR"
+
+APPSCAN_DIR="$ISSM_DIR/externalpackages/appscan/install"
+pathappend "$APPSCAN_DIR/bin"
+
+RATS_DIR="$ISSM_DIR/externalpackages/rats/install"
+pathappend "$RATS_DIR/bin"
+
+DYSON_DIR="$ISSM_DIR/externalpackages/dyson/"
+pathappend "$DYSON_DIR"
+
+CMAKE_DIR="$ISSM_DIR/externalpackages/cmake/install"
+pathappend "$CMAKE_DIR/bin"
+
+SHAPELIB_DIR="$ISSM_DIR/externalpackages/shapelib/install"
+pathappend "$SHAPELIB_DIR/exec"
+
+CCCL_DIR="$ISSM_DIR/externalpackages/cccl/install"
+pathappend "$CCCL_DIR/bin"
+
+PACKAGEMAKER_DIR="$ISSM_DIR/externalpackages/packagemaker/install"
+pathappend "$PACKAGEMAKER_DIR"
+
+ANDROID_NDK_DIR="$ISSM_DIR/externalpackages/android-ndk/install"
+pathappend "$ANDROID_NDK_DIR/"
+
+ANDROID_SDK_DIR="$ANDROID_DIR/android-sdk/install-sdk"
+pathappend "$ANDROID_SDK_DIR/"
+
+GSL_DIR="$ISSM_DIR/externalpackages/gsl/install"
+libpathappend "$GSL_DIR/lib"
+
+GMAKE_DIR="$ISSM_DIR/externalpackages/gmake/install"
+pathprepend "$GMAKE_DIR/bin"
+
+PYTHON_DIR="$ISSM_DIR/externalpackages/python/install"
+if [ -d "$PYTHON_DIR" ]; then
+	export PYTHONPATH="$PYTHONPATH:$ISSM_DIR/lib"
+	export PYTHONSTARTUP="$ISSM_DIR/startup.py"
+	pathprepend    "$PYTHON_DIR/bin"
+	libpathprepend "$ISSM_DIR/lib"
+	libpathprepend "$PYTHON_DIR/lib"
+fi
+
+MODELE_DIR="$ISSM_DIR/externalpackages/modelE/install"
+pathappend "$MODELE_DIR/src/exec"
+
+GIT_DIR="$ISSM_DIR/externalpackages/git/install"
+pathappend "$GIT_DIR/bin"
+
+NCVIEW_DIR="$ISSM_DIR/externalpackages/ncview/install"
+pathappend "$NCVIEW_DIR"
+
+TCLX_DIR="$ISSM_DIR/externalpackages/tclx/install/lib/tclx8.4"
+libpathappend "$TCLX_DIR"
+
+ASPELL_DIR="$ISSM_DIR/externalpackages/aspell/install"
+pathappend "$ASPELL_DIR/bin"
+
+HDF5_DIR="$ISSM_DIR/externalpackages/hdf5/install"
+if [ -d "$HDF5_DIR" ]; then
+	dylibpathappend "$HDF5_DIR/lib"
+	libpathappend "$HDF5_DIR/lib"
+	export LIBRARY_PATH="$LIBRARY_PATH:$HDF5_DIR/lib"
+	export C_INCLUDE_PATH="$C_INCLUDE_PATH:$HDF5_DIR/include"
+fi
+
+#NETCDF
+NETCDF_DIR="$ISSM_DIR/externalpackages/netcdf/install"
+if [ -d "$NETCDF_DIR" ]; then
+	export DYLD_LIBRARY_PATH="$DYLD_LIBRARY_PATH:$NETCDF_DIR/lib"
+	export LD_LIBRARY_PATH="$LD_LIBRARY_PATH:$NETCDF_DIR/lib"
+	export LIBRARY_PATH="$LIBRARY_PATH:$NETCDF_DIR/lib"
+	export C_INCLUDE_PATH="$C_INCLUDE_PATH:$NETCDF_DIR/include"
+fi
+
+#SVN
+SVN_DIR="$ISSM_DIR/externalpackages/svn/install"
+if [ -d "$SVN_DIR" ]; then
+	pathprepend   "$SVN_DIR/bin"
+	libpathappend "$SVN_DIR/lib"
+fi
+
+APR_DIR="$ISSM_DIR/externalpackages/apr/install"
+if [ -d "$APR_DIR" ]; then
+	pathappend    "$APR_DIR/bin"
+	libpathappend "$APR_DIR/lib"
+fi
+
+APR_UTIL_DIR="$ISSM_DIR/externalpackages/apr-util/install"
+pathappend   "$APR_UTIL_DIR/bin:$PATH"
+libpathappend "$APR_UTIL_DIR/lib"
+
+SQLITE_DIR="$ISSM_DIR/externalpackages/sqlite/install"
+pathappend   "$SQLITE_DIR/bin"
+libpathappend "$SQLITE_DIR/lib"
+
+YAMS_DIR="$ISSM_DIR/externalpackages/yams/install"
+pathappend   "$YAMS_DIR"
+
+SWIG_DIR="$ISSM_DIR/externalpackages/swig/install"
+pathappend   "$SWIG_DIR"
Index: issm/trunk/externalpackages/adic/install.sh
===================================================================
--- issm/trunk/externalpackages/adic/install.sh	(revision 12709)
+++ issm/trunk/externalpackages/adic/install.sh	(revision 13395)
@@ -1,3 +1,4 @@
 #!/bin/bash
+set -eu
 
 #Erase install
@@ -26,5 +27,5 @@
 	--with-colpack=$ISSM_DIR/externalpackages/colpack/install\
 	--prefix=$ISSM_DIR/externalpackages/adic/install 
-if [ -z $1 ]; then
+if [ $# -eq 0 ]; then
 	make
 else
Index: issm/trunk/externalpackages/adolc/install-dev.sh
===================================================================
--- issm/trunk/externalpackages/adolc/install-dev.sh	(revision 13395)
+++ issm/trunk/externalpackages/adolc/install-dev.sh	(revision 13395)
@@ -0,0 +1,20 @@
+#!/bin/bash
+set -eu
+
+#Some cleanup
+rm -rf install adolc_v220_issm
+
+git clone -b 2.3.x_ISSM  git://gitorious.org/~utke/adol-c/adolc_v220_issm.git 
+
+#Compile ADOL-C
+cd adolc_v220_issm
+
+autoreconf -f -i 
+./configure --prefix=$ISSM_DIR/externalpackages/adolc/install 
+
+if [ $# -eq 0 ]; then
+	make
+else
+	make -j $1
+fi
+make install
Index: issm/trunk/externalpackages/adolc/install.sh
===================================================================
--- issm/trunk/externalpackages/adolc/install.sh	(revision 12709)
+++ issm/trunk/externalpackages/adolc/install.sh	(revision 13395)
@@ -1,14 +1,15 @@
 #!/bin/bash
+set -eu
 
 #some issues on macosx64 with ISSM's autoconf. you might want to run native to mac on this.
 
 #Some cleanup
-rm -rf install ADOL-C-2.2.0 src
+rm -rf install ADOL-C-2.2.0 src trunk
+
+#Create install directories
+mkdir install src
 
 #Download from ISSM server
 $ISSM_DIR/scripts/DownloadExternalPackage.py 'http://issm.jpl.nasa.gov/files/externalpackages/ADOL-C-2.2.0.tar.gz' 'ADOL-C-2.2.0.tar.gz'
-
-#Create install directories
-mkdir install src
 
 #Untar 
@@ -22,8 +23,8 @@
 cd src 
 
-export CC=gcc
-export CXX=g++
-export CFLAGS="-arch x86_64"
-export CXXFLAGS="-arch x86_64"
+#export CC=gcc
+#export CXX=g++
+#export CFLAGS="-arch x86_64"
+#export CXXFLAGS="-arch x86_64"
 
 ./configure \
@@ -34,5 +35,5 @@
 	--disable-shave
 
-if [ -z $1 ]; then
+if [ $# -eq 0 ]; then
 	make
 else
@@ -40,2 +41,20 @@
 fi
 make install
+
+
+#Ok, bug with libtool: replace all LIBTOOL= by LIBTOOL=libtool 
+#in all Makefiles
+for i in `find ./ -name Makefile `
+do
+	echo $i
+	cat $i | sed 's/LIBTOOL =/LIBTOOL = libtool/g' > $i.bak 
+	mv $i.bak $i
+done
+
+#remake: 
+if [ $# -eq 0 ]; then
+	make
+else
+	make -j $1
+fi
+make install
Index: issm/trunk/externalpackages/android/android-ndk/install.sh
===================================================================
--- issm/trunk/externalpackages/android/android-ndk/install.sh	(revision 12709)
+++ issm/trunk/externalpackages/android/android-ndk/install.sh	(revision 13395)
@@ -1,27 +1,32 @@
-#This installs the Android NDK (Native Development Kit)
-#which is needed for the compilation of C/C++ code into the 
-#native architecture of the Android device.
+#!/bin/bash
+set -eu
 
-#The android-ndk-r8-darwin-x86.tar.bz2 ndk.tar.bz2 file was downloaded 
-#from the android developer website: 
-source $ANDROID_DIR/android_variables.sh
+# This installs the Android NDK (Native Development Kit)
+# which is needed for the compilation of C/C++ code into the 
+# native architecture of the Android device.
 
-#Cleanup the install
-rm -rf install
-rm -rf $ANDROID_DIR/arm-linux-android-${default_droid}
+# The android-ndk-r8-darwin-x86.tar.bz2 ndk.tar.bz2 file was downloaded 
+# from the android developer website: 
+source $ANDROID_DIR/android_aux.sh
 
-#Download from ISSM server
-$ISSM_DIR/scripts/DownloadExternalPackage.py 'http://issm.jpl.nasa.gov/files/externalpackages/android-ndk-r'${ndk_rev}'-darwin-x86.tar.bz2' 'ndk.tar.bz2'
+if [[ $step == "1" || $step == "0" ]]; then
+    # Cleanup the install
+    rm -rf install
+    rm -rf $ANDROID_DIR/arm-linux-android-${default_droid}
 
-# Install Android SDK and NDK.
-bunzip2 ndk.tar.bz2
-tar -xvf ndk.tar
-rm -rf ndk.tar ndk.tar.bz2
+    # Download from ISSM server
+    $ISSM_DIR/scripts/DownloadExternalPackage.py 'http://issm.jpl.nasa.gov/files/externalpackages/android-ndk-r'${ndk_rev}'-darwin-x86.tar.bz2' 'ndk.tar.bz2'
 
-#Move to install
-mv android-ndk-r${ndk_rev} install
+    # Untar
+    tar -zxvf ndk.tar.bz2
+    rm -rf ndk.tar ndk.tar.bz2
 
-#Create Standalone Development Directory
-#Note: API-14 corresponds to Android 4.0 although we are
-#calling our toolchain 4.1 to agree with our device.
-$ANDROID_NDK_DIR/build/tools/make-standalone-toolchain.sh --platform=android-14 --install-dir=$ANDROID_DIR/arm-linux-android-4.0
+    # Move to install
+    mv android-ndk-r${ndk_rev} install
+fi
+
+# Create Standalone Development Directory
+# Note: API-14 corresponds to Android 4.0.
+if [[ $step == "2" || $step == "0" ]]; then
+    $ANDROID_NDK_DIR/build/tools/make-standalone-toolchain.sh --platform=android-14 --install-dir=$ANDROID_DIR/arm-linux-android-4.0
+fi
Index: issm/trunk/externalpackages/android/android-sdk/install.sh
===================================================================
--- issm/trunk/externalpackages/android/android-sdk/install.sh	(revision 12709)
+++ issm/trunk/externalpackages/android/android-sdk/install.sh	(revision 13395)
@@ -1,31 +1,26 @@
-#This installs the Android SDK (Software Development Kit)
-#which is needed for the compilation of the Java project. 
-source $ANDROID_DIR/android_variables.sh
+#!/bin/bash
+set -eu 
 
-step=1;
+# This installs the Android SDK (Software Development Kit)
+# which is needed for the compilation of the Java project. 
 
-#Different steps here. 
-#1: install sdk, ant and sdk tools
-#2: install an emulator.
-#3: test the emulator
-#4: cleanup
+source $ANDROID_DIR/android_aux.sh
+
+# Different steps here. 
+#   0: do all
+#   1: install sdk, ant and sdk tools
+#   2: install an emulator.
+#   3: test the emulator
+#   4: cleanup
 
 present_dir=`pwd`;
 sd_card="issm-sdcard"
 
-((tmp=$1 )) 
+if [[ $step == "1" || $step == "0" ]]; then
 
-if [[ $tmp -ge "1" && $tmp -le "4" ]]; then
-    step=$1
-else
-    echo "Using default step: " $step
-fi
-
-if [[ $step == "1" ]]; then
-
-	#Cleanup the install
+	# Cleanup the install
 	rm -rf install-sdk
 
-	#Download from ISSM server
+	# Download from ISSM server
 	$ISSM_DIR/scripts/DownloadExternalPackage.py 'http://issm.jpl.nasa.gov/files/externalpackages/android-sdk_r'$sdk_rev'-macosx.zip' 'android-sdk_r'${sdk_rev}'-macosx.zip'
 
@@ -33,15 +28,15 @@
 	unzip -o android-sdk_r${sdk_rev}-macosx.zip
 
-	#Move to install
+	# Move to install
 	mv -f android-sdk-macosx install-sdk
 
-	#Post_install configuration: 
-	#We need specific settings for specific platforms, for the SDK to 
-	#function properly
+	# Post_install configuration: 
+	# We need specific settings for specific platforms, for the SDK to 
+	# function properly
 
-	#For now, we need to install:  
-	#android sdk platform tools  
-	#and a specific android api: API 16, API 15 and API 14
-	#Note: API 16, API 15 and 14 correspond to Android 4.1, 4.0.3 and 4.0 respectively. 
+	# For now, we need to install:  
+	# android sdk platform tools  
+	# and a specific android api: API 16, API 15 and API 14
+	# Note: API 16, API 15 and 14 correspond to Android 4.1, 4.0.3 and 4.0 respectively. 
 
 	cd install-sdk/tools/ && source ./android update sdk -t platform-tool,${api_levels},system-image --no-ui
@@ -49,11 +44,11 @@
 fi
 
-if [[ $step == "2" ]]; then
+if [[ $step == "2" || $step == "0" ]]; then
 
-	#Once this is done, we need to install an emulator. Location will default to ~/.android/avd, 
-	#which we will move to $ISSM_DIR/externalpackages/android-emulators.  
-	#For now, it's called: Android-4.0.3
+	# Once this is done, we need to install an emulator. Location will default to ~/.android/avd, 
+	# which we will move to $ISSM_DIR/externalpackages/android-emulators.  
+	# For now, it's called: Android-4.0.3
 
-	#Here we delete the Android-4.0.3 device if it already exists.
+	# Here we delete the Android-4.0.3 device if it already exists.
 	cd $present_dir/install-sdk/tools
 
@@ -64,6 +59,6 @@
     fi
 
-	#Android will prompt the user to specify hardware emulation options. For now, default
-	#default settings will suffice. Press 'enter' to take default settings or enter 'no'.
+	# Android will prompt the user to specify hardware emulation options. For now, default
+	# default settings will suffice. Press 'enter' to take default settings or enter 'no'.
 
 	./android create avd -f -n $default_droid -t 1 -p $ANDROID_DIR/android-emulators/$default_droid --abi armeabi-v7a
@@ -72,8 +67,8 @@
 fi
 
-if [[ $step == "3" ]]; then
-    #Here we will start up our default emulator to test that it is working properly.
-    #Once the device has booted we will use the Android Debug Bridge tool to gain
-    #a terminal in our device.
+if [[ $step == "3" || $step == "0" ]]; then
+    # Here we will start up our default emulator to test that it is working properly.
+    # Once the device has booted we will use the Android Debug Bridge tool to gain
+    # a terminal in our device.
 
 	cd $present_dir/install-sdk/tools
@@ -82,12 +77,7 @@
     cd ../platform-tools
     ./adb wait-for-device shell
-    #./adb wait-for-device shell mount -o rw,remount -t yaffs2 /dev/block/mtdblock1 /system
-    #./adb wait-for-device shell
-    #./adb push $ISSM_TIER/src/c/issm.exe /data/issm.exe
-    #./adb shell chmod 777 /data/issm.exe
-    #./adb shell /data/issm.exe
 fi
 
-if [[ $step == "4" ]]; then
+if [[ $step == "4" || $step == "0" ]]; then
 	rm -rf install-sdk
 fi
Index: issm/trunk/externalpackages/android/android_aux.sh
===================================================================
--- issm/trunk/externalpackages/android/android_aux.sh	(revision 13395)
+++ issm/trunk/externalpackages/android/android_aux.sh	(revision 13395)
@@ -0,0 +1,30 @@
+#!/bin/bash
+#
+# android_aux.sh serves as an auxiliary script for all installation
+# scripts with the Android suffix.
+#
+# TODO: include M4 macros for generic options.
+#
+
+sdk_rev=20
+ndk_rev=8
+api_levels="android-14,android-15,android-16"
+host_triplet="arm-linux-androideabi"
+default_droid="android-4.1"
+
+step=0;
+j=1;
+
+echo Number of arguments is: $#
+for arg in $* 
+do 
+    if [[ "$arg" =~ --step=([0-9])* ]]; then
+        step=${BASH_REMATCH[1]}; 
+        echo "Setting step to: " $step
+    elif [[ "$arg" =~ -j=([1-9]+[0-9]*) || "$arg" =~ ([1-9]+[0-9]*) ]]; then
+        j=${BASH_REMATCH[1]}; 
+        echo "Number of jobs set to: " $j
+    else
+        echo "Option not recognized"
+    fi
+done
Index: issm/trunk/externalpackages/angel/install.sh
===================================================================
--- issm/trunk/externalpackages/angel/install.sh	(revision 12709)
+++ issm/trunk/externalpackages/angel/install.sh	(revision 13395)
@@ -1,3 +1,4 @@
 #!/bin/bash
+set -eu
 
 #Some cleanup
Index: issm/trunk/externalpackages/appscan/install.sh
===================================================================
--- issm/trunk/externalpackages/appscan/install.sh	(revision 12709)
+++ issm/trunk/externalpackages/appscan/install.sh	(revision 13395)
@@ -1,3 +1,4 @@
 #!/bin/bash
+set -eu
 
 #AppScan install directory. Just symlink to your existing AppScan software
Index: issm/trunk/externalpackages/apr-util/install.sh
===================================================================
--- issm/trunk/externalpackages/apr-util/install.sh	(revision 13395)
+++ issm/trunk/externalpackages/apr-util/install.sh	(revision 13395)
@@ -0,0 +1,30 @@
+#!/bin/bash
+set -eu
+
+#Some cleanup
+rm -rf src
+rm -rf install
+rm -rf apr-util-1.4.1
+mkdir src install
+
+#Download from ISSM server
+$ISSM_DIR/scripts/DownloadExternalPackage.py 'http://issm.jpl.nasa.gov/files/externalpackages/apr-util-1.4.1.tar.gz' 'apr-util-1.4.1.tar.gz'
+
+#Untar 
+tar -zxvf  apr-util-1.4.1.tar.gz
+
+#Move apr-util into src directory
+mv apr-util-1.4.1/* src
+rm -rf apr-util-1.4.1
+
+#Configure apr-util
+cd src
+./configure  --prefix="$ISSM_DIR/externalpackages/apr-util/install" --with-apr="$ISSM_DIR/externalpackages/apr/install"
+
+#Compile and install apr-util
+if [ $# -eq 0 ]; then
+	make
+else
+	make -j $1
+fi
+make install
Index: issm/trunk/externalpackages/apr/install.sh
===================================================================
--- issm/trunk/externalpackages/apr/install.sh	(revision 13395)
+++ issm/trunk/externalpackages/apr/install.sh	(revision 13395)
@@ -0,0 +1,30 @@
+#!/bin/bash
+set -eu
+
+#Some cleanup
+rm -rf src
+rm -rf install
+rm -rf apr-1.4.6
+mkdir src install
+
+#Download from ISSM server
+$ISSM_DIR/scripts/DownloadExternalPackage.py 'http://issm.jpl.nasa.gov/files/externalpackages/apr-1.4.6.tar.gz' 'apr-1.4.6.tar.gz'
+
+#Untar 
+tar -zxvf  apr-1.4.6.tar.gz
+
+#Move apr into src directory
+mv apr-1.4.6/* src
+rm -rf apr-1.4.6
+
+#Configure apr
+cd src
+./configure  --prefix="$ISSM_DIR/externalpackages/apr/install" 
+
+#Compile and install apr
+if [ $# -eq 0 ]; then
+	make
+else
+	make -j $1
+fi
+make install
Index: issm/trunk/externalpackages/aspell/install.sh
===================================================================
--- issm/trunk/externalpackages/aspell/install.sh	(revision 12709)
+++ issm/trunk/externalpackages/aspell/install.sh	(revision 13395)
@@ -1,8 +1,9 @@
 #!/bin/bash
+set -eu
 
 #0: cleanup
 #1:  install aspell
 #2:  install en dictionary
-step=0
+step=2
 
 
Index: issm/trunk/externalpackages/autotools/install.sh
===================================================================
--- issm/trunk/externalpackages/autotools/install.sh	(revision 13395)
+++ issm/trunk/externalpackages/autotools/install.sh	(revision 13395)
@@ -0,0 +1,44 @@
+#!/bin/bash
+set -eu
+
+rm -rf install
+mkdir install
+
+export PATH="$ISSM_DIR/externalpackages/autotools/install/bin:$PATH"
+
+#install autoconf
+echo " === INSTALLING AUTOCONF =="
+rm -rf src
+$ISSM_DIR/scripts/DownloadExternalPackage.py 'http://issm.jpl.nasa.gov/files/externalpackages/autoconf-2.68.tar.gz' 'autoconf-2.68.tar.gz'
+tar -zxvf autoconf-2.68.tar.gz
+mv autoconf-2.68 src
+cd src 
+./configure --prefix="$ISSM_DIR/externalpackages/autotools/install" 
+make  
+make install
+cd ..
+
+#install automake
+echo " === INSTALLING AUTOMAKE =="
+rm -rf src
+$ISSM_DIR/scripts/DownloadExternalPackage.py 'http://issm.jpl.nasa.gov/files/externalpackages/automake-1.11.3.tar.gz' 'automake-1.11.3.tar.gz'
+tar -zxvf  automake-1.11.3.tar.gz
+mv automake-1.11.3 src
+cd src 
+./configure --prefix="$ISSM_DIR/externalpackages/autotools/install" 
+make  
+make install
+cd ..
+
+#install libtool
+echo " === INSTALLING LIBTOOL =="
+rm -rf src
+$ISSM_DIR/scripts/DownloadExternalPackage.py 'http://issm.jpl.nasa.gov/files/externalpackages/libtool-2.4.2.tar.gz' 'libtool-2.4.2.tar.gz'
+tar -zxvf  libtool-2.4.2.tar.gz
+rm libtool-2.4.2.tar.gz
+mv libtool-2.4.2 src
+cd src 
+./configure --prefix="$ISSM_DIR/externalpackages/autotools/install" 
+make  
+make install
+cd ..
Index: issm/trunk/externalpackages/bbftp/install.sh
===================================================================
--- issm/trunk/externalpackages/bbftp/install.sh	(revision 12709)
+++ issm/trunk/externalpackages/bbftp/install.sh	(revision 13395)
@@ -1,3 +1,4 @@
 #!/bin/bash
+set -eu
 
 #Some cleanup
Index: issm/trunk/externalpackages/blas/configs/macosx64/make.inc
===================================================================
--- issm/trunk/externalpackages/blas/configs/macosx64/make.inc	(revision 13395)
+++ issm/trunk/externalpackages/blas/configs/macosx64/make.inc	(revision 13395)
@@ -0,0 +1,34 @@
+####################################################################
+#  BLAS make include file.                                         #
+#  March 2007                                                      #
+####################################################################
+#
+SHELL = /bin/sh
+#
+#  The machine (platform) identifier to append to the library names
+#
+PLAT = _LINUX
+#  
+#  Modify the FORTRAN and OPTS definitions to refer to the
+#  compiler and desired compiler options for your machine.  NOOPT
+#  refers to the compiler options desired when NO OPTIMIZATION is
+#  selected.  Define LOADER and LOADOPTS to refer to the loader and 
+#  desired load options for your machine.
+#
+FORTRAN  = gfortran
+OPTS     = -fPIC -O3
+DRVOPTS  = $(OPTS)
+NOOPT    =
+LOADER   = gfortran
+LOADOPTS =
+#
+#  The archiver and the flag(s) to use when building archive (library)
+#  If you system has no ranlib, set RANLIB = echo.
+#
+ARCH     = ar
+ARCHFLAGS= cr
+RANLIB   = ranlib
+#
+#  The location and name of the Reference BLAS library.
+#
+BLASLIB      = blas$(PLAT).a
Index: issm/trunk/externalpackages/blas/install-linux64.sh
===================================================================
--- issm/trunk/externalpackages/blas/install-linux64.sh	(revision 12709)
+++ issm/trunk/externalpackages/blas/install-linux64.sh	(revision 13395)
@@ -1,3 +1,4 @@
 #!/bin/bash
+set -eu 
 
 #Some cleanup
Index: issm/trunk/externalpackages/blas/install-macosx64.sh
===================================================================
--- issm/trunk/externalpackages/blas/install-macosx64.sh	(revision 13395)
+++ issm/trunk/externalpackages/blas/install-macosx64.sh	(revision 13395)
@@ -0,0 +1,29 @@
+#!/bin/bash
+set -eu 
+
+#Some cleanup
+rm -rf src install BLAS blas.tgz
+mkdir install src
+
+#Download from ISSM server
+$ISSM_DIR/scripts/DownloadExternalPackage.py 'http://issm.jpl.nasa.gov/files/externalpackages/blas.tgz' 'blas.tgz'
+
+#Untar 
+tar -zxvf  blas.tgz
+
+#Move blas into install directory
+mv BLAS/* src
+rm -rf BLAS
+
+#install
+cd src 
+cp ../configs/macosx64/make.inc ./
+make 
+
+#Compile 
+cd ../install
+mkdir lib
+cd lib
+cp ../../src/*.a .
+ln -s blas_LINUX.a blas.a
+ln -s blas_LINUX.a libblas.a
